import 'dart:ui';
import 'package:provider/provider.dart';

import 'package:tencent_im_sdk_plugin/models/v2_tim_friend_info.dart';
import 'package:tencent_im_sdk_plugin/tencent_im_sdk_plugin.dart';
import 'package:flutter/material.dart';
import 'package:dio/dio.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_value_callback.dart';

import 'package:tencent_im_sdk_plugin/models/v2_tim_event_callback.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_user_full_info.dart';

import 'package:tencent_im_sdk_plugin_example/pages/home/home.dart';
import 'package:tencent_im_sdk_plugin_example/provider/conversion.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_conversation.dart';
import 'package:tencent_im_sdk_plugin_example/provider/friend.dart';
import 'package:tencent_im_sdk_plugin_example/provider/user.dart';
import 'package:toast/toast.dart';

var timBaseColor = Color(int.parse('006fff', radix: 16)).withAlpha(255);
var timLogo = AssetImage("images/logo.png");

class LoginPage extends StatefulWidget {
  @override
  _LoginPageState createState() => _LoginPageState();
}

class _LoginPageState extends State<LoginPage> {
  Future<void> initState() {
    super.initState();
    test();
  }

  listener(V2TimEventCallback data) {
    print("init sdk listener emit");
    print(data.type);
    // print(data.toJson());
  }

  groupListener(data) {
    print("groupListener emit");
    print(data);
  }

  advancedMsgListener(V2TimEventCallback data) {
    print("advancedMsgListener emit");
    print(data.type);
    // print(data.toJson());
  }

  friendListener(V2TimEventCallback data) {
    print("friendListener emit");
    String type = data.type;
    if (type == 'onFriendListAdded') {
      //好友加成功了，
      List<V2TimFriendInfo> list = data.data;
      List<V2TimFriendInfo> oldList =
          Provider.of<FriendListModel>(context, listen: false).friendList;
      if (oldList == null || oldList.length == 0) {
        oldList = [];
      }
      oldList.addAll(list);
      Provider.of<FriendListModel>(context, listen: false)
          .setFriendList(oldList);
    }
    print(data.type);
  }

  Map<String, V2TimConversation> conversationlistToMap(
      List<V2TimConversation> list) {
    Map<int, V2TimConversation> convsersationMap = list.asMap();
    Map<String, V2TimConversation> newConversation = new Map();
    convsersationMap.forEach((key, value) {
      newConversation[value.conversationID] = value;
    });
    return newConversation;
  }

  conversationListener(V2TimEventCallback data) {
    String type = data.type;

    if (type == 'onNewConversation' || type == 'onConversationChanged') {
      print("${type} emit");
      try {
        List<V2TimConversation> renderList =
            Provider.of<ConversionModel>(context, listen: false).conversionList;

        List<V2TimConversation> list = data.data;

        Map<String, V2TimConversation> renderConversationMap =
            conversationlistToMap(renderList);
        Map<String, V2TimConversation> updateConversationMap =
            conversationlistToMap(list);
        updateConversationMap.forEach((key, value) {
          renderConversationMap[key] = value;
        });
        List<V2TimConversation> updateList =
            renderConversationMap.values.toList();
        Provider.of<ConversionModel>(context, listen: false)
            .setConversionList(updateList);
      } catch (e) {}
    } else {
      print("${type} emit but no nerver use");
    }
  }

  signalingListener(data) {
    print("signalingListener emit");
    // print(data);
  }

  simpleMsgListener(V2TimEventCallback data) {
    //这里区分消息
    print("simpleMsgListener emit");
    print(data.type);
    // print(data.toJson());
  }

  test() async {
    await tencent_im_sdk_plugin.v2TIMManager.initSDK(
      sdkAppID: 1400425583,
      loglevel: 0,
      listener: listener,
    );

    //简单监听
    tencent_im_sdk_plugin.v2TIMManager.addSimpleMsgListener(
      listener: simpleMsgListener,
    );

    //群组监听
    tencent_im_sdk_plugin.v2TIMManager.setGroupListener(
      listener: groupListener,
    );
    //高级消息监听
    tencent_im_sdk_plugin.v2TIMManager
        .getMessageManager()
        .addAdvancedMsgListener(
          advancedMsgListener,
        );
    //关系链监听
    tencent_im_sdk_plugin.v2TIMManager.getFriendshipManager().setFriendListener(
          listener: friendListener,
        );
    //会话监听
    tencent_im_sdk_plugin.v2TIMManager
        .getConversationManager()
        .setConversationListener(
          conversationListener,
        );
    tencent_im_sdk_plugin.v2TIMManager
        .getSignalingManager()
        .addSignalingListener(
          signalingListener,
        );
    print("初始化完成了");

    // Map res =  await tencent_im_sdk_plugin.v2TIMManager
    //     .setSelfInfo(nickName: 'hahaha11122233');
    // await tencent_im_sdk_plugin.v2TIMManager.addSimpleMsgListener();
    // await tencent_im_sdk_plugin.v2TIMManager.login(
    //   "clavieliu",
    //   "eJwtzE0PwUAUheH-MlvSXjXDtImFoEJIhG5INzW96lIyGaORiv*uX8vznOT9smhzcAo0LGCeA6zfbErxaelCDas8KQhzenfnK70nWlPKggEH4J4Qctg**NFksHIhhAcArVp61DaqgPtj3*8qlNVto5dHpaSMrM1i9zRFdd3ZbXiGeU8uSpqVq9gNlcH1bZ9N2O8Pq5w0Dg__",
    // );
    // print("登录完成了");

    // await tencent_im_sdk_plugin.v2TIMManager.getLoginUser();
    // print("获取用户信息完成了");
    // await tencent_im_sdk_plugin.v2TIMManager.getLoginStatus();
    // Map data = await tencent_im_sdk_plugin.v2TIMManager.sendC2CTextMessage(
    //   "hello",
    //   "clavieliu",
    // );
    // print(22222);
    // print(data);
    // tencent_im_sdk_plugin.v2TIMManager
    //     .getConversationManager()
    //     .setConversationListener();

    // List<String> userIdLists = new List();
    // userIdLists.add("xingchenhe");
    // print(userIdLists);
    // await tencent_im_sdk_plugin.v2TIMManager.getUsersInfo(userIdLists);
    // Map data = await tencent_im_sdk_plugin.v2TIMManager
    //     .sendC2CCustomMessage("test", "clavieliu");
    // print(data);
    // Map data = await tencent_im_sdk_plugin.v2TIMManager.sendGroupCustomMessage(
    //   "哈哈哈哈哈哈哈",
    //   "@TGS#1UJ2UNWGR",
    //   1,
    // );
    // print(data);
    // tencent_im_sdk_plugin.v2TIMManager.createGroup(
    //   "AVChatRoom",
    //   "testgroupid",
    //   "flutter创建",
    // );
    // tencent_im_sdk_plugin.v2TIMManager.createGroup(
    //   "Work",
    //   "flutter创建无id",
    //   null,
    // );
    // tencent_im_sdk_plugin.v2TIMManager.quitGroup("testgroupid");
    // tencent_im_sdk_plugin.v2TIMManager.dismissGroup("@TGS#aASIUNWGP");
    // tencent_im_sdk_plugin.v2TIMManager
    //     .getConversationManager()
    //     .getConversationList(0, 1);
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        body: new AppLayout(),
      ),
    );
  }
}

class AppLayout extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        AppLogo(),
        Expanded(
          child: LoginForm(),
        )
      ],
    );
  }
}

class AppLogo extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Container(
      height: 192.0,
      color: timBaseColor,
      alignment: Alignment.topLeft,
      padding: EdgeInsets.only(
        top: 108.0,
      ),
      child: Row(
        children: <Widget>[
          Container(
            height: 90,
            width: 90,
            child: Image(
              image: timLogo,
              width: 90.0,
              height: 90.0,
            ),
          ),
          Container(
            height: 90.0,
            padding: EdgeInsets.only(
              top: 10,
            ),
            child: Column(
              children: <Widget>[
                Text(
                  '登录·即时通信',
                  style: TextStyle(
                    color: Color.fromARGB(255, 255, 255, 255),
                    fontSize: 28,
                  ),
                ),
                Text(
                  '体验群组聊天，音视频对话等M功能',
                  style: TextStyle(
                    color: Color.fromARGB(255, 255, 255, 255),
                    fontSize: 12,
                  ),
                ),
              ],
              crossAxisAlignment: CrossAxisAlignment.start,
            ),
          )
        ],
      ),
    );
  }
}

class LoginForm extends StatefulWidget {
  _LoginFormState createState() => _LoginFormState();
}

class _LoginFormState extends State<LoginForm> {
  void initState() {}
  String tel = '';
  String pwd = '';
  void getHttp() async {
    try {
      Response response = await Dio().get(
        "https://service-qr8jjnpm-1256635546.gz.apigw.tencentcs.com/release/getUserSig?userId=xingchenhe",
      );
      print(response);
    } catch (e) {
      print(e);
    }
  }

  void getLoginCode(context) async {
    if (tel.length == 0) {
      Toast.show(
        "请输入正确的手机号码",
        context,
        duration: Toast.LENGTH_SHORT,
        gravity: Toast.TOP,
      );
    } else {
      Dio dio = new Dio();
      Response response = await dio.get(
          "https://service-c2zjvuxa-1252463788.gz.apigw.tencentcs.com/release/flutterSms",
          queryParameters: {
            "method": "getSms",
            "phone": tel,
          });
    }
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      // color: Colors.amber,
      padding: EdgeInsets.fromLTRB(16, 64, 16, 0),
      child: Form(
        child: Column(
          children: [
            TextField(
              autofocus: false,
              decoration: InputDecoration(
                labelText: "手机号",
                hintText: "请输入手机号码",
                icon: Icon(Icons.phone_android),
              ),
              keyboardType: TextInputType.number,
              onChanged: (v) {
                setState(() {
                  tel = v;
                });
              },
            ),
            Row(
              children: [
                Expanded(
                  child: TextField(
                    decoration: InputDecoration(
                      labelText: "验证码",
                      hintText: "请输入验证码",
                      icon: Icon(Icons.lock),
                    ),
                    keyboardType: TextInputType.number,
                    //校验密码
                    onChanged: (v) {
                      setState(() {
                        pwd = v;
                      });
                    },
                  ),
                ),
                Container(
                  width: 120,
                  child: RaisedButton(
                    child: Text("获取验证码"),
                    color: timBaseColor,
                    textColor: Colors.white,
                    onPressed: () {
                      //获取验证码
                      getLoginCode(context);
                    },
                  ),
                )
              ],
            ),
            Container(
              margin: EdgeInsets.only(
                top: 28,
              ),
              child: Row(
                children: [
                  Expanded(
                    child: RaisedButton(
                      padding: EdgeInsets.only(
                        top: 15,
                        bottom: 15,
                      ),
                      child: Text("登录"),
                      color: timBaseColor,
                      textColor: Colors.white,
                      onPressed: () async {
                        var data =
                            await tencent_im_sdk_plugin.v2TIMManager.login(
                          userID: "xingchenhe",
                          userSig:
                              "eJwtzMsKgzAQheF3ybZFEs3gBbpoQQTJQrBot1LHOFiD2mCF0nevqMvzHfi-7K5yZ8aJRcx1ODtvm2o0lhraeCGjny2aFo-3XXfVMFDNIiE5ly5A4O0PLgNNuDoAuJzzXS31m4VhIKQvg6NCeo0XsVAP2Vnom9Ibi6SfSzNmWZhjXKVJKrT6QF75t9PremG-P3dgMxU_",
                        );
                        // var data =
                        //     await tencent_im_sdk_plugin.v2TIMManager.login(
                        //   userID: "clavieliu",
                        //   userSig:
                        //       "eJwtzE0PwUAUheH-MlvSXjXDtImFoEJIhG5INzW96lIyGaORiv*uX8vznOT9smhzcAo0LGCeA6zfbErxaelCDas8KQhzenfnK70nWlPKggEH4J4Qctg**NFksHIhhAcArVp61DaqgPtj3*8qlNVto5dHpaSMrM1i9zRFdd3ZbXiGeU8uSpqVq9gNlcH1bZ9N2O8Pq5w0Dg__",
                        // );
                        // micooli
                        // eJwtzE8LgjAcxvH3snPYz-2pJXSJ6JBRhyIQupRb9mtbE50SRO89U4-P54Hvh5x2x6jVFUkIjYBM*o1KvwLesWeHufcWx6tW5lqWqEgScwBOhZBsePS7xEp3LoSgADBoQPe3GXAGQKUYK1h0ZWsP-jJVK7tNm6cv7N60slmrlNabLCxuWewMgNdnNn-IJfn*APlYMuM_
                        // var data =
                        //     await tencent_im_sdk_plugin.v2TIMManager.login(
                        //   userID: "micooli",
                        //   userSig:
                        //       "eJwtzE8LgjAcxvH3snPYz-2pJXSJ6JBRhyIQupRb9mtbE50SRO89U4-P54Hvh5x2x6jVFUkIjYBM*o1KvwLesWeHufcWx6tW5lqWqEgScwBOhZBsePS7xEp3LoSgADBoQPe3GXAGQKUYK1h0ZWsP-jJVK7tNm6cv7N60slmrlNabLCxuWewMgNdnNn-IJfn*APlYMuM_",
                        // );
                        if (data.code != 0) {
                          print('登录失败');
                          return;
                        }
                        V2TimValueCallback<List<V2TimUserFullInfo>> infos =
                            await tencent_im_sdk_plugin.v2TIMManager
                                .getUsersInfo(userIDList: ['xingchenhe']);
                        if (infos.code == 0) {
                          Provider.of<UserModel>(context, listen: false)
                              .setInfo(infos.data[0]);
                        }
                        Navigator.push(
                          context,
                          new MaterialPageRoute(
                            builder: (context) => HomePage(),
                          ),
                        );
                        // V2TimValueCallback<V2TimMessage> data1 =
                        //     await tencent_im_sdk_plugin.v2TIMManager
                        //         .sendC2CTextMessage('nihaonihao', 'clavieliu');
                        // print(data1.data.textElem.text);
                        // V2TimValueCallback<V2TimMessage> data2 =
                        //     await tencent_im_sdk_plugin.v2TIMManager
                        //         .sendC2CCustomMessage('Nihao1', 'clavieliu');
                        // print(2233);
                        // print(data2.data.customElem.data);
                        // V2TimValueCallback<String> data1 =
                        //     await tencent_im_sdk_plugin.v2TIMManager
                        //         .createGroup(
                        //   groupType: GroupType.Work,
                        //   groupName: "测试4",
                        // );
                        // print('测试二');
                        // print(data1.data);
                        // V2TimCallback data1 =
                        //     await tencent_im_sdk_plugin.v2TIMManager.joinGroup(
                        //   groupID: "testgroupid",
                        //   message: "woyao1jiaqun",
                        // );
                        // V2TimValueCallback<String> data1 =
                        //     await tencent_im_sdk_plugin.v2TIMManager
                        //         .getGroupManager()
                        //         .createGroup(
                        //             groupName: "haha",
                        //             groupType: GroupType.Work);
                        // V2TimValueCallback<List<V2TimUserFullInfo>> data1 =
                        //     await tencent_im_sdk_plugin.v2TIMManager
                        //         .getUsersInfo(
                        //   userIDList: ['xingchenhe', 'clavieliu'],
                        // );
                        // V2TimCallback data1 = await tencent_im_sdk_plugin
                        //     .v2TIMManager
                        //     .setSelfInfo(nickName: "mkji");
                        // print("12312");
                        // V2TimValueCallback<List<V2TimGroupInfo>> data1 =
                        //     await tencent_im_sdk_plugin.v2TIMManager
                        //         .getGroupManager()
                        //         .getJoinedGroupList();
                        //
                        // V2TimValueCallback<List<V2TimGroupInfoResult>> data1 =
                        //     await tencent_im_sdk_plugin.v2TIMManager
                        //         .getGroupManager()
                        //         .getGroupsInfo(groupIDList: [
                        //   "@TGS#1RFVVRYGW",
                        //   "@TGS#1HKTVRYGP"
                        // ]);
                        // V2TimValueCallback<V2TimGroupApplicationResult> data1 =
                        //     await tencent_im_sdk_plugin.v2TIMManager
                        //         .getGroupManager()
                        //         .getGroupApplicationList();

                        // print(2222);
                        // print(data1);
                      },
                    ),
                  )
                ],
              ),
            )
          ],
        ),
      ),
    );
  }
}
